/******************************************************************************
globus_poll.h

Description:

  A general polling infrastructure

  For now, to keep things simple, I have defined the routines such that the
  poll list cannot be modified when a polling operation is in progress.
  Perhaps this should be a topic of discussion at some point.  --BRT
  
CVS Information:

  $Source: /home/globdev/CVS/globus-1998_04_16/Globus/Miscellaneous/common/library/globus_poll.h,v $
  $Date: 1998/06/13 22:10:58 $
  $Revision: 1.6 $
  $State: Exp $
  $Author: bester $
******************************************************************************/

#if !defined(GLOBUS_INCLUDE_GLOBUS_POLL)
#define GLOBUS_INCLUDE_GLOBUS_POLL 1

/******************************************************************************
			     Include header files
******************************************************************************/
#include "globus_common.h"


#ifndef EXTERN_C_BEGIN
#ifdef __cplusplus
#define EXTERN_C_BEGIN extern "C" {
#define EXTERN_C_END }
#else
#define EXTERN_C_BEGIN
#define EXTERN_C_END
#endif
#endif

EXTERN_C_BEGIN

/******************************************************************************
			       Type definitions
******************************************************************************/
typedef
globus_bool_t
(*globus_poll_func_t)(
    globus_bool_t			blocking_allowed);


/******************************************************************************
			      Function prototypes
******************************************************************************/
void
globus_poll_blocking(void);

void
globus_poll_nonblocking(void);

#define globus_poll()	globus_poll_nonblocking()

int
globus_poll_add(
    globus_poll_func_t			polling_func,
    int					frequency);

int
globus_poll_remove(
    globus_poll_func_t			polling_func);


/******************************************************************************
			       Module definition
******************************************************************************/
extern globus_module_descriptor_t	globus_i_poll_module;

#define GLOBUS_POLL_MODULE (&globus_i_poll_module)

EXTERN_C_END

#endif /* GLOBUS_INCLUDE_GLOBUS_POLL */
