/******************************************************************************
CIF_Toolkit_Mutex.C

Description:

  A mutex exclusion class to guarantee exclusive access to critcal sections.
  
CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Comm-C++-Current/library/CIF_Toolkit_Mutex.C,v $
  $Date: 1998/09/08 05:18:57 $
  $Revision: 1.1 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

/******************************************************************************
			     Include header files
******************************************************************************/
#include "CIF_Toolkit.H"


/******************************************************************************
			Define CIF_Toolkit_Mutex class
******************************************************************************/

CIF_Toolkit_Mutex::CIF_Toolkit_Mutex()
{
    globus_mutex_init(&l_mutex, (globus_mutexattr_t *) GLOBUS_NULL);
}

    
CIF_Toolkit_Mutex::~CIF_Toolkit_Mutex()
{
    globus_mutex_destroy(&l_mutex);
}


void
CIF_Toolkit_Mutex::lock()
{
    globus_mutex_lock(&l_mutex);
}


void
CIF_Toolkit_Mutex::unlock()
{
    globus_mutex_unlock(&l_mutex);
}
